image: node:8-alpine

cache:
  key: "$CI_COMMIT_REF_NAME"
  paths:
    - node_modules/

stages:
  - build
  - dockerize

build:
  stage: build
  script: 
    - npm install
    - npm run build    
  artifacts:
    paths:
      - dist/
      - Dockerfile
      - package.json
      - package-lock.json

dockerize_review:
  image: docker:latest
  services:
    - docker:dind
  stage: dockerize
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG .
    - docker push $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG
  only: 
    - branches

dockerize_tag:
  image: docker:latest
  services:
    - docker:dind
  stage: dockerize
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  only: 
    - tags

